<link rel="import" href="chrome://resources/html/polymer.html">

<link rel="import" href="chrome://resources/cr_elements/cr_toolbar/cr_toolbar_search_field.html">
<link rel="import" href="chrome://resources/html/assert.html">
<link rel="import" href="chrome://resources/html/cr/ui/focus_row.html">
<link rel="import" href="chrome://resources/html/i18n_behavior.html">
<link rel="import" href="chrome://resources/mojo/mojo/public/mojom/base/string16.mojom.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-a11y-announcer/iron-a11y-announcer.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-dropdown/iron-dropdown.html">
<link rel="import" href="chrome://resources/polymer/v1_0/iron-list/iron-list.html">
<link rel="import" href="os_search_result_row.html">
<link rel="import" href="../metrics_recorder.html">
<link rel="import" href="../search_handler.html">
<link rel="import" href="../../settings_shared_css.html">
<link rel="import" href="../../router.html">

<dom-module id="os-settings-search-box">
  <template>
    <style include="settings-shared">
      :host {
        --cr-toolbar-focused-min-height: 40px;
        --cr-toolbar-icon-container-size: 32px;
        --cr-toolbar-icon-margin: 8px 16px;
        --cr-toolbar-search-field-icon-opacity: 1;
        --cr-toolbar-search-field-narrow-mode-prompt-opacity: 1;
        --cr-toolbar-search-field-prompt-opacity: 1;
        --cr-toolbar-search-icon-margin-inline-start: 16px;
        --cr-toolbar-query-exists-min-height:
            var(--cr-toolbar-focused-min-height);
        --separator-height: 8px;
        -webkit-tap-highlight-color: transparent;
        display: flex;
        flex-basis: var(--cr-toolbar-field-width);
        transition: width 150ms cubic-bezier(0.4, 0, 0.2, 1);
        width: var(--cr-toolbar-field-width);
      }

      @media (prefers-color-scheme: dark) {
        :host {
          --cr-toolbar-search-field-narrow-mode-prompt-opacity: 1;
        }
      }

      /* Only search icon is visible in this mode */
      :host([narrow]:not([showing-search])) {
        /* Row flex keeps magnifying glass on the rightmost edge. */
        flex-direction: row;
        justify-content: flex-end;
      }

      :host([narrow][showing-search]) {
        justify-content: center;
      }

      cr-toolbar-search-field {
        --cr-toolbar-search-field-term-margin: 0;
        --cr-toolbar-search-field-border-radius: 20px;
        --cr-toolbar-search-field-paper-spinner-margin: 0 12px;
        --cr-toolbar-search-field-input-text-color:
            var(--cr-primary-text-color);
        font-size: 13px;
      }

      :host([showing-search]) cr-toolbar-search-field {
        background:
            var(--cr-toolbar-search-field-background, rgba(0, 0, 0, 0.22));
      }

      :host([narrow]:not([showing-search])) cr-toolbar-search-field {
        padding-inline-end: 10px;
      }

      :host(:focus-within[showing-search]) cr-toolbar-search-field {
        --cr-toolbar-search-field-background: var(--cr-card-background-color);
        box-shadow: var(--cr-elevation-1);
        min-height: var(--cr-toolbar-focused-min-height);
      }

      :host([has-search-query]) cr-toolbar-search-field {
        min-height: var(--cr-toolbar-query-exists-min-height);
      }

      :host(:not(:focus-within)) cr-toolbar-search-field {
        --cr-toolbar-search-field-cursor: pointer;
      }

      :host(:focus-within[should-show-dropdown_]) cr-toolbar-search-field {
        --cr-toolbar-search-field-border-radius: 20px 20px 0 0;
        box-shadow: var(--cr-elevation-3);
        height: 56px;
        margin-top: var(--separator-height);
        padding-bottom: var(--separator-height);
      }

      iron-dropdown {
        margin-top: 74px;
      }

      iron-dropdown [slot='dropdown-content'] {
        background-color: var(--cr-menu-background-color);
        border-radius: 0 0 20px 20px;
        box-shadow: var(--cr-elevation-3);
        display: table;
        padding-bottom: 16px;
        width: var(--cr-toolbar-field-width);
      }

      iron-list {
        max-height: 50vh;
      }

      #noSearchResultsContainer {
        height: 24px;
        margin-inline-start: 64px;
        margin-top: var(--separator-height);
      }

      /* The separator covers the top box shadow of the dropdown so that
       * var(--cr-elevation-3) can be used instead of custom values. */
      .separator {
        background-color: var(--cr-menu-background-color);
        border-bottom: none;
        border-inline-end: none;
        border-inline-start: none;
        border-top: 2px solid var(--cr-separator-color);
        height: var(--separator-height);
        margin-inline-end: 0;
        margin-inline-start: 0;
        margin-top: -10px;
      }
    </style>
    <cr-toolbar-search-field id="search" narrow="[[narrow]]"
        on-search-icon-clicked="onSearchIconClicked_"
        label="$i18n{searchPrompt}" clear-label="$i18n{clearSearch}"
        showing-search="{{showingSearch}}" spinner-active="[[spinnerActive]]">
    </cr-toolbar-search-field>
    <iron-dropdown id="searchResults" opened="[[shouldShowDropdown_]]"
        allow-outside-scroll no-cancel-on-outside-click>
      <!--  As part of iron-dropdown's behavior, the slot 'dropdown-content' is
            hidden until iron-dropdown's opened attribute is set true, or when
            iron-dropdown's open() is called on the JS side. -->
      <div slot="dropdown-content">
        <div class="separator"></div>
        <iron-list id="searchResultList" selection-enabled risk-selection
            items="[[searchResults_]]" selected-item="{{selectedItem_}}"
            on-selected-item-changed="onSelectedItemChanged_">
          <template>
            <os-search-result-row actionable search-result="[[item]]"
                search-query="[[getCurrentQuery_(searchResults_)]]"
                selected="[[isItemSelected_(item, selectedItem_)]]"
                tabindex$="[[getRowTabIndex_(item, selectedItem_,
                    shouldShowDropdown_)]]"
                iron-list-tab-index$="[[getRowTabIndex_(item, selectedItem_,
                    shouldShowDropdown_)]]"
                on-navigated-to-result-route="onNavigatedToResultRowRoute_"
                last-focused="{{lastFocused_}}"
                list-blurred="{{listBlurred_}}"
                list-length="[[getListLength_(searchResults_)]]"
                focus-row-index="[[index]]"
                first$="[[!index]]">
            </os-search-result-row>
          </template>
        </iron-list>
        <div id="noSearchResultsContainer" hidden="[[searchResultsExist_]]">
          $i18n{searchNoResults}
        </div>
      </div>
    </iron-dropdown>
  </template>
  <script src="os_settings_search_box.js"></script>
</dom-module>
